Imports System.Runtime.InteropServices
Imports System.Data.OleDb
Imports System.IO
Imports Microsoft.Win32
Public Class frmCamera
    Dim bmap As Image
#Region "LoadDeviceList"
    Private Sub LoadDeviceList()
        Dim strName As String = Space(1000)
        Dim strVer As String = Space(1000)
        Dim bReturn As Boolean
        Dim x As Integer = 0
        '   
        '    + 
        bReturn = capGetDriverDescriptionA(x, strName, 100, strVer, 100)
        If bReturn Then iDevice = 0
    End Sub
#End Region
#Region "OpenPreviewWindow"
    Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
       (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, _
       <MarshalAs(UnmanagedType.AsAny)> ByVal lParam As Object) As Integer
    Private Sub OpenPreviewWindow()
        Dim iHeight As Integer = PictureBox1.Height
        Dim iWidth As Integer = PictureBox1.Width
        '    
        hHwnd = capCreateCaptureWindowA(iDevice, WS_VISIBLE Or WS_CHILD, 0, 0, 640, _
            480, PictureBox1.Handle.ToInt32, 0)
        '  
        If SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, iDevice, 0) Then
            '  
            SendMessage(hHwnd, WM_CAP_SET_SCALE, True, 0)
            ' 
            SendMessage(hHwnd, WM_CAP_SET_PREVIEWRATE, 66, 0)
            '    
            SendMessage(hHwnd, WM_CAP_SET_PREVIEW, True, 0)
            '   
            SetWindowPos(hHwnd, HWND_BOTTOM, 0, 0, PictureBox1.Width, PictureBox1.Height, _
                    SWP_NOMOVE Or SWP_NOZORDER)
            ButtonXP3.Enabled = True
            ButtonXP1.Enabled = True
            ButtonXP2.Enabled = False
        Else
            '    
            DestroyWindow(hHwnd)
            ButtonXP3.Enabled = False
            ButtonXP1.Enabled = False
        End If
    End Sub
#End Region
    Private Sub frmEgyCamera_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        LoadDeviceList()
        If iDevice >= 0 Then
            Me.ButtonXP2.Enabled = True
        Else
            MessageBox.Show("   ", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.ButtonXP2.Enabled = False
        End If
        ButtonXP3.Enabled = False
        ButtonXP1.Enabled = False
        PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage
    End Sub
    Private Sub ButtonXP2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP2.Click
        On Error Resume Next
        OpenPreviewWindow()
    End Sub
#Region "ClosePreviewWindow"
    Private Sub ClosePreviewWindow()
        On Error Resume Next
        '   
        SendMessage(hHwnd, WM_CAP_DRIVER_DISCONNECT, iDevice, 0)
        '  
        DestroyWindow(hHwnd)
    End Sub
#End Region
#Region "frmEgyWebCamera_Closing"
    Private Sub frmEgyCamera_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        On Error Resume Next
        ClosePreviewWindow()
    End Sub
#End Region
    Private Sub ButtonXP3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP3.Click
        On Error Resume Next
        Scan = False
        SaveFromScan("file")
        f.Show()
        Me.Hide()
    End Sub
    Private Sub ButtonXP1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP1.Click
        On Error Resume Next
        frmEgyCamera_Load(sender, e)
        Scan = True
        SaveFromScan("Database")
        f.Show()
        f.Activate()
        Me.Close()
    End Sub
    Private Sub SaveFromScan(ByVal parm As String)
        On Error Resume Next
        Me.Cursor = Cursors.WaitCursor
        Dim data As IDataObject
        '   
        SendMessage(hHwnd, WM_CAP_EDIT_COPY, 0, 0)
        '       
        data = Clipboard.GetDataObject()
        If data.GetDataPresent(GetType(System.Drawing.Bitmap)) Then
            bmap = CType(data.GetData(GetType(System.Drawing.Bitmap)), Image)
            PictureBox1.Image = bmap
            ClosePreviewWindow()
            ButtonXP3.Enabled = False
            ButtonXP1.Enabled = False
            ButtonXP2.Enabled = True
        End If
        If parm = "Database" Then
            If IO.Directory.Exists(Application.StartupPath & "\PHOTOS") Then IO.Directory.Delete(Application.StartupPath & "\PHOTOS", True)
            If Not IO.Directory.Exists(Application.StartupPath & "\PHOTOS") Then IO.Directory.CreateDirectory(Application.StartupPath & "\PHOTOS")
            Scan = True
            myimage = Application.StartupPath & "\PHOTOS\EgyGroupVip" & ".jpg"
            bmap.Save(myimage)
        ElseIf parm = "file" Then
            sd.Title = "... "
            sd.Filter = "Bitmap file (*.bmp)|*.bmp|TIFF file (*.tif)|*.tif|JPEG file (*.jpg)|*.jpg|PNG file (*.png)|*.png|GIF file (*.gif)|*.gif|All files (*.*)|*.*"
            sd.FilterIndex = 1
            If sd.ShowDialog() <> System.Windows.Forms.DialogResult.OK Then
                Exit Sub
            End If
            If Len(sd.FileName) > 0 Then
                bmap.Save(sd.FileName, Imaging.ImageFormat.Jpeg)
            End If
        End If
        Me.Cursor = Cursors.Default
    End Sub
End Class
