Imports System.Runtime.InteropServices
Imports System.Data.OleDb
Imports System.IO
Imports Microsoft.Win32
Imports System
Imports System.Windows.Forms
Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Public Class frmScanner
    Inherits System.Windows.Forms.Form
    Implements IMessageFilter
    Dim WithEvents BS As New BindingSource
    Private msgfilter As Boolean
    Private tw As Twain
    Private picnumber As Integer = 0
    Dim bmi As BITMAPINFOHEADER
    Dim bmprect As Rectangle
    Dim dibhand As IntPtr
    Dim bmpptr As IntPtr
    <DllImport("gdi32.dll", ExactSpelling:=True)> Friend Shared Function SetDIBitsToDevice(ByVal hdc As IntPtr, ByVal xdst As Integer, ByVal ydst As Integer, ByVal width As Integer, ByVal height As Integer, ByVal xsrc As Integer, ByVal ysrc As Integer, ByVal start As Integer, ByVal lines As Integer, ByVal bitsptr As IntPtr, ByVal bmiptr As IntPtr, ByVal color As Integer) As Integer
    End Function
    <DllImport("kernel32.dll", ExactSpelling:=True)> Friend Shared Function GlobalLock(ByVal handle As IntPtr) As IntPtr
    End Function
    <DllImport("kernel32.dll", ExactSpelling:=True)> Friend Shared Function GlobalFree(ByVal handle As IntPtr) As IntPtr
    End Function
    <DllImport("kernel32.dll", CharSet:=CharSet.Auto)> Public Shared Sub OutputDebugString(ByVal outstr As String)
    End Sub
    <DllImport("gdiplus.dll", ExactSpelling:=True)> Friend Shared Function GdipCreateBitmapFromGdiDib(ByVal bminfo As IntPtr, ByVal pixdat As IntPtr, ByRef image As IntPtr) As Integer
    End Function
    <DllImport("gdiplus.dll", ExactSpelling:=True, CharSet:=CharSet.Unicode)> Friend Shared Function GdipSaveImageToFile(ByVal image As IntPtr, ByVal filename As String, <[In]()> ByRef clsid As Guid, ByVal encparams As IntPtr) As Integer
    End Function
    <DllImport("gdiplus.dll", ExactSpelling:=True)> Friend Shared Function GdipDisposeImage(ByVal image As IntPtr) As Integer
    End Function
    Private Shared codecs() As ImageCodecInfo = ImageCodecInfo.GetImageEncoders()
    Dim pixptr As IntPtr
    <STAThread()> Sub Main()
        On Error Resume Next
        If (Twain.ScreenBitDepth < 15) Then
            MessageBox.Show("     !", "  ", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
        Dim f As frmMain = New frmMain()
        Application.Run(f)
    End Sub
    Public Sub New()
        On Error Resume Next
        InitializeComponent()
        tw = New Twain()
        tw.Init(Me.Handle)
    End Sub
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        On Error Resume Next
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Private Function PreFilterMessage(ByRef m As Message) As Boolean Implements IMessageFilter.PreFilterMessage
        On Error Resume Next
        Dim cmd As TwainCommand = tw.PassMessage(m)
        If (cmd = TwainCommand.Not) Then
            Return False
        End If
        Select Case cmd
            Case TwainCommand.CloseRequest
                EndingScan()
                tw.CloseSrc()
            Case TwainCommand.CloseOk
                EndingScan()
                tw.CloseSrc()
            Case TwainCommand.DeviceEvent
            Case TwainCommand.TransferReady
                Dim pics As ArrayList = tw.TransferPictures()
                EndingScan()
                tw.CloseSrc()
                Dim num As Integer = 1
                Dim i As Integer
                Dim img As IntPtr = CType(pics(i), IntPtr)
                Dim pic As Integer = 1
                Me.Text = "Photo" + num.ToString() + "_" + pic.ToString()
                dibhand = img
                bmpptr = GlobalLock(dibhand)
                pixptr = GetPixelInfo(bmpptr)
                Scan = True
        End Select
        Return True
    End Function
    Private Sub ButtonXP2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP2.Click
        On Error Resume Next
        frmEgyScanner1_Load(sender, e)
        tw.Select()
        If (Not msgfilter) Then
            Me.Enabled = False
            msgfilter = True
            Application.AddMessageFilter(Me)
        End If
        tw.Acquire()
    End Sub
    Private Sub EndingScan()
        On Error Resume Next
        If (msgfilter) Then
            Application.RemoveMessageFilter(Me)
            msgfilter = False
            Me.Enabled = True
            Me.Activate()
            Me.Refresh()
            Me.WindowState = FormWindowState.Minimized
            Me.WindowState = FormWindowState.Normal
        End If
    End Sub
    Protected Function GetPixelInfo(ByVal bmpptr As IntPtr) As IntPtr
        On Error Resume Next
        bmi = New BITMAPINFOHEADER()
        Marshal.PtrToStructure(bmpptr, bmi)
        bmprect.X = bmprect.Y = 0
        bmprect.Width = bmi.biWidth
        bmprect.Height = bmi.biHeight
        If (bmi.biSizeImage = 0) Then
            bmi.biSizeImage = Int((((bmi.biWidth * bmi.biBitCount) + 31) & Hex(Not (31))) / 2 ^ 3) * bmi.biHeight
        End If
        Dim p As Integer = bmi.biClrUsed
        If ((p = 0) And (bmi.biBitCount <= 8)) Then
            p = Int(1 * 2 ^ bmi.biBitCount)
        End If
        p = (p * 4) + bmi.biSize + CType(bmpptr.ToInt32, Integer)
        Return New IntPtr(p)
    End Function
    Private Function SaveScanToFile(ByVal picname As String, ByVal bminfo As IntPtr, ByVal pixdat As IntPtr) As Boolean
        On Error Resume Next
        sd.FileName = picname
        sd.Title = " ..."
        sd.Filter = "Bitmap file (*.bmp)|*.bmp|TIFF file (*.tif)|*.tif|JPEG file (*.jpg)|*.jpg|PNG file (*.png)|*.png|GIF file (*.gif)|*.gif|All files (*.*)|*.*"
        sd.FilterIndex = 1
        If sd.ShowDialog() <> System.Windows.Forms.DialogResult.OK Then
            Return False
        End If
        Dim clsid As Guid
        If Not GetCodecClsid(sd.FileName, clsid) Then
            MessageBox.Show("   " + Path.GetExtension(sd.FileName), "Image Codec", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If
        Dim img As IntPtr = IntPtr.Zero
        Dim st As Integer = GdipCreateBitmapFromGdiDib(bminfo, pixdat, img)
        If (st <> 0) Or (Equals(img, IntPtr.Zero)) Then
            Return False
        End If
        st = GdipSaveImageToFile(img, sd.FileName, clsid, IntPtr.Zero)
        GdipDisposeImage(img)
        Scan = False
        PictureBox1.Image = Image.FromFile(sd.FileName)
        Return st = 0
    End Function
    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        On Error Resume Next
        Dim hdc As IntPtr = e.Graphics.GetHdc()
        SetDIBitsToDevice(hdc, 0, 0, 0, 0, 0, 0, 0, 0, pixptr, bmpptr, 0)
        e.Graphics.ReleaseHdc(hdc)
        SaveScanToDatabase(Me.Text, bmpptr, pixptr, Me.PictureBox1, Me)
    End Sub
    Private Sub frmEgyScanner1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage
    End Sub
    Private Sub ButtonXP3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP3.Click
        On Error Resume Next
        EndingScan()
        tw.CloseSrc()
        Me.Cursor = Cursors.WaitCursor
        SaveScanToFile(Me.Text, bmpptr, pixptr)
        Me.Cursor = Cursors.Default
    End Sub
    Private Sub ButtonXP1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonXP1.Click
        On Error Resume Next
        Scan = True
        f.Show()
        Me.Close()
    End Sub
End Class
